// Exercise 9.7 p. 388

function exp(x: int, y: int) returns (z: int);
axiom (forall x: int :: exp(x,0) == 1);
axiom (forall x: int, y: int :: exp(x,y) == mult(x,exp(x,y-1)));

// For good old multiplication in the logic.
function mult(x: int, y: int) returns (z: int);
// Multiplication is associative.
axiom (forall x: int, y: int, z: int :: mult(x, mult(y, z)) == mult(mult(x, y), z));

// Instead of using *, we'll use times:
procedure times(x: int, y: int) returns (z: int);
        ensures z == mult(x,y);
        
// For integer division in the logic.
function div(x: int, y: int) returns (z: int);

// Instead of using /, we'll use divide:
procedure divide(x: int, y: int) returns (z: int);
        ensures z == div(x, y);
        
// A predicate for the logic expressing that a number is even.
function even(x: int) returns (b: bool);

// Instead of using x % 2 == 0 in our program, we'll call is_even.
procedure is_even(x: int) returns (b: bool);
        ensures (b == even(x));

// A relationship between even, exp, mult and div:
axiom (forall x: int, y: int :: even(y) ==> (exp(mult(x,x),div(y,2)) == exp(x,y)));

var z: int;
var m, n: int;

// Anything multiplied by 1 is itself.
axiom (forall x: int :: mult(x, 1) == x);
// Instead of saying mult commutes, we'll simply do the other side too.
axiom (forall x: int :: mult(1, x) == x);

procedure exercise_9_7()
//        requires exp(m,n) == k;
        ensures z == exp(m, n);
        modifies z;
{
        var x, y: int;
        var b: bool;
        
        x := m; y := n; z := 1;
        while (y != 0)
                invariant (mult(z,exp(x,y)) == exp(m, n));
        {
                call b := is_even(y);
                if (!b) {
                           y := y - 1;
                           call z := times(z,x);
                } else {
                           call y := divide(y, 2);
                           call x := times(x, x);
                }
        }
}

procedure exercise_9_7_alternative()
        ensures z == exp(m, n);
        modifies z;
{
        var x, y: int;
        
        x := m; y := n; z := 1;
        while (y != 0)
                invariant (mult(z,exp(x,y)) == exp(m, n));
        {
                if (!even(y)) {
                           y := y - 1;
                           z := mult(z,x);
                } else {
                           y := div(y, 2);
                           x := mult(x, x);
                }
        }
}
